define(["dojo/_base/declare","dojo/_base/lang","dojo/_base/array","dojo/on","dojo/mouse","dojo/ready","dojo/when","dojo/dom-style","dojo/dom-class","dojo/Deferred","dijit/_WidgetBase","dijit/_TemplatedMixin","dijit/_WidgetsInTemplateMixin","epi/shell/dnd/Target","epi/shell/widget/dialog/Alert","epi-cms/contentediting/_ContextualContentContextMixin","adaptiveimages/_LogMixin","adaptiveimages/AdaptiveImagesStore","adaptiveimages/helpers/FilesizeValidator","adaptiveimages/helpers/ContentHelper","adaptiveimages/widget/dialog/CropDialog","adaptiveimages/widget/editors/mixins/_DropImageFileMixin","adaptiveimages/widget/editors/mixins/_ThumbnailUrlResolverMixin","dojo/i18n!./nls/Labels","dojo/text!./ImageDetailsEditor.html","xstyle/css!./ImageDetailsEditor.css"],(function(i,t,e,o,n,s,a,r,h,d,l,m,g,p,u,c,f,v,z,S,w,I,b,_,P){return i([l,m,g,f,I,b],{debugLogName:"ImageDetailsEditor",templateString:P,name:null,displayName:null,imageId:null,localized:_,validProportions:null,minimumSize:null,loader:null,readOnly:!1,cmsImageProviderName:"optimizely",provider:null,filename:null,left:null,right:null,top:null,bottom:null,width:null,height:null,alternateText:null,_dialogService:null,_adaptiveImagesStore:null,constructor:function(){this.inherited(arguments),this._adaptiveImagesStore=new v},_setImageIdAttr:function(i){this._set("imageId",i),this._setThumbnail()},_setProviderAttr:function(i){if(i&&"string"!=typeof i)throw"Adaptive image provider name must be a string if specified";this._set("provider",i)},_openCropDialog:function(i){var t;this.imageId&&(this.own(t=new w({title:`${_.dialogs.crop} ${this.displayName?this.displayName.toLowerCase():""}`.trim(),provider:this.provider,imageId:this.imageId,filename:this.filename,validProportions:this.validProportions,minimumSize:this.minimumSize,model:{left:this.get("left"),right:this.get("right"),top:this.get("top"),bottom:this.get("bottom")},onOkAction:function(i){["left","right","top","bottom"].forEach(function(t){this.set(t,i[t])}.bind(this)),this.imageCropped(i,this.name)}.bind(this)})),t.show())},_target:null,postCreate:function(){this.inherited(arguments),this.onUploadStart=function(){this.loader.show()}.bind(this),this.onUploadComplete=function(i){this._handleEpiserverImageDrop(i)}.bind(this)},postMixInProperties:function(){this.inherited(arguments)},startup:function(){if(this.inherited(arguments),!this.validProportions||!this.validProportions.length)throw"No valid proportions specified";this.readOnly?h.add(this.editorContainer,"dijitReadOnly"):(this._target=new p(this.dropzone,{accept:["adaptiveimage","link"],createItemOnDrop:!1}),o(this._target,"DropData",this._onDrop.bind(this)),o(this.cropOption,"click",this._openCropDialog.bind(this)),o(this.thumbnailImage,"click",this._openCropDialog.bind(this)),o(this.resetCropOption,"click",function(){return a(this._dialogService.confirmation({title:_.dialogs.resetCrop.title,description:_.dialogs.resetCrop.description}),function(){this.log("Resetting crop settings..."),["left","right","top","bottom"].forEach(function(i){this.set(i,null)}.bind(this)),this.imageCropped(null,this.name)}.bind(this),(function(i){}))}.bind(this)),o(this.dropzone,n.enter,function(){this._setCropResetButtonVisibility()}.bind(this)))},imageDropped:function(i,t,e){},imageCropped:function(i,t){},hasSizeConstraint:function(){return this.minimumSize&&(this.minimumSize.width>0||this.minimumSize.height>0)},hasProportionsConstraint:function(){let i=!1;return e.some(this.validProportions,(function(t){if(t.x>0&&t.y>0)return i=!0,!1}))[0],this.log(i?"Proportions constraints apply":"No proportions constraints apply",{validProportions:this.validProportions}),i},validateImageSizeAndProportions:function(i,t){this.log(this.name?`Validating image of ${i}x${t} pixels for form factor '${this.name}'...`:`Validating image of ${i}x${t} pixels`);var o={name:this.name,displayName:this.displayName,imageSize:i&&t?{width:i,height:t}:null,validSize:!0,validProportions:!0,sizeConstraint:this.minimumSize,proportionsConstraint:this.validProportions[0]};if(this.hasSizeConstraint())if((o.imageSize.width<this.minimumSize.width||o.imageSize.height<this.minimumSize.height)&&(this.logWarn(`Image${this.name?" for "+this.name:""} does not fulfill size restriction: width >= ${this.minimumSize.width}, height >= ${this.minimumSize.height}`),o.validSize=!1),this.hasProportionsConstraint())if(1===this.validProportions.length){this.log("Validating image fulfills proportions constraint...",this.validProportions[0]);var n=parseInt(this.minimumSize.width/(this.validProportions[0].x/this.validProportions[0].y));o.imageSize.height<n&&(this.logWarn(`Height of ${o.imageSize.height} does not meet minimum proportionate height of ${n}`),o.sizeConstraint.height=Math.max(n,o.sizeConstraint.height),o.validProportions=!1);var s=parseInt(this.minimumSize.height*(this.validProportions[0].x/this.validProportions[0].y));o.imageSize.width<s&&(this.logWarn(`Width of ${o.imageSize.width} does not meet minimum proportionate width of ${s}`),o.sizeConstraint.width=Math.max(s,o.sizeConstraint.width),o.validProportions=!1)}else{this.log("Validating image fulfills at least one of the valid proportions...",this.validProportions);let i=e.filter(this.validProportions,function(i){if(i.isFreeForm)return!0;var t=parseInt(this.minimumSize.width/(i.x/i.y)),e=parseInt(this.minimumSize.height*(i.x/i.y));return o.imageSize.height>=t&&o.imageSize.width>=e?(this.log(`Image is valid for '${i.x}:${i.y}' proportions while maintaining a minimum size of ${t}x${t} px`,{proportions:i,resultImageSize:o.imageSize,minimumSize:this.minimumSize,proportionateMinimumSize:{width:e,height:t}}),!0):void 0}.bind(this));if(i&&i.length){let t=!1;if(e.some(i,(function(i){if(i.isDefault)return t=!0,!1})),!t){let i="";this.minimumSize.width>0&&this.minimumSize.height>0?i=_.dialogs.wrongProportions.description.doesNotMatchDefaultProportions.minSize:this.minimumSize.width>0?i=_.dialogs.wrongProportions.description.doesNotMatchDefaultProportions.minWidthOnly:this.minimumSize.height>0?i=_.dialogs.wrongProportions.description.doesNotMatchDefaultProportions.minHeightOnly:(this.logWarn("Image validation failed despite there being no size constraints."),i=_.dialogs.wrongProportions.title),this._displaySizeValidationAlert(i)}}else o.validProportions=!1}else o.validProportions=!0;return o},validateImageSizeAndProportionsOfExternalImage:function(i,t){this.log(`Validating image with ID '${t}' from provider '${i}'...`);var e=new d(function(i){this.log("Image size check cancelled",i)}.bind(this)),o=this.hasSizeConstraint(),n=this.hasSizeConstraint();if(o||n)this._adaptiveImagesStore.getMetaData(i,t).then(function(i){var t=this.validateImageSizeAndProportions(i.width,i.height);e.resolve(t)}.bind(this));else{var s=this.validateImageSizeAndProportions();e.resolve(s)}return e},_onDrop:function(i,t,e,o){var n=i?i.length?i[0]:i:null;n&&a(n.data,function(i){n.type.includes("adaptiveimage")&&i.imageId?this._handleExternalAdaptiveImageDrop(i):n.type.includes("link")?this._handleEpiserverImageDrop(i):this.logWarn("Unexpected drop",n)}.bind(this))},_isValidFilesize:function(){const i=new z;var t=new d;return a(i.isValidFilesize.apply(this,arguments),function(i){i||new u({heading:_.dialogs.exceedingFilesize.title,description:_.dialogs.exceedingFilesize.description}).show(),t.resolve(i)}.bind(this)),t},_handleExternalAdaptiveImageDrop:function(i){this.log("Adaptive image dropped",i),a(this._isValidFilesize(i.provider,i.imageId),function(t){t&&this.validateImageSizeAndProportionsOfExternalImage(i.provider,i.imageId).then(function(t){this.log("Validated image size and proportions",t),this._displayAlertIfDimensionsAreInvalid(t)||(this._set("imageId",i.imageId),this._set("filename",i.name),this._set("provider",i.provider),this._set("width",i.width),this._set("height",i.height),["left","right","top","bottom"].forEach(function(i){this._set(i,null)}.bind(this)),this.imageDropped(i.provider,i.imageId,this.name))}.bind(this))}.bind(this))},_handleEpiserverImageDrop:function(i){this.log("Handling data as Episerver image drop...",i);var t=i.permanentUrl||i.permanentLink;this.log(`Validating image: ${t}...`),a(S.getContentFromUrl(t),function(i){this.log("CMS image dropped",i),a(this._isValidFilesize(this.cmsImageProviderName,i.contentGuid),function(t){t&&a(S.getRemoteImageDimensions(i.downloadUrl),function(t){this.log(`Dropped image is ${t.width}x${t.height} pixels`);var e=this.validateImageSizeAndProportions(t.width,t.height);this.log("Validated image size and proportions",e),this._displayAlertIfDimensionsAreInvalid(e)||(this._set("imageId",i.contentGuid),this._set("filename",S.getFilenameFromUrl(i.publicUrl)),this._set("provider",this.cmsImageProviderName),this._set("width",t.width),this._set("height",t.height),["left","right","top","bottom"].forEach(function(i){this._set(i,null)}.bind(this)),this.imageDropped(this.cmsImageProviderName,i.contentGuid,this.name))}.bind(this))}.bind(this))}.bind(this))},_displayAlertIfDimensionsAreInvalid:function(i){var t;if(!i.validSize)return this.minimumSize.width>0&&this.minimumSize.height>0?t=_.dialogs.imageTooSmall.description.size.replace("{size}",`${this.minimumSize.width}x${this.minimumSize.height}`):this.minimumSize.width>0?t=_.dialogs.imageTooSmall.description.width.replace("{width}",`${this.minimumSize.width}`):this.minimumSize.height>0&&(t=_.dialogs.imageTooSmall.description.height.replace("{height}",`${this.minimumSize.height}`)),new u({heading:_.dialogs.imageTooSmall.title,description:t}).show(),!0;if(!i.validProportions){let i="";return this.validProportions.length>1?this.minimumSize.width>0&&this.minimumSize.height>0?i=_.dialogs.wrongProportions.description.noneMatching.minSize:this.minimumSize.width>0?i=_.dialogs.wrongProportions.description.noneMatching.minWidthOnly:this.minimumSize.height>0?i=_.dialogs.wrongProportions.description.noneMatching.minHeightOnly:(this.logWarn("Image validation failed despite there being no size constraints."),i=_.dialogs.wrongProportions.title):i=this.minimumSize.width>0?_.dialogs.wrongProportions.description.widthConstraint:this.minimumSize.height>0?_.dialogs.wrongProportions.description.heightConstraint:_.dialogs.wrongProportions.description.default,this._displaySizeValidationAlert(i),!0}return!1},_displaySizeValidationAlert:function(i){let t=this.validProportions.length>1?e.map(this.validProportions,(i=>`${i.name} (${i.x}:${i.y})`)).join(", "):"";new u({heading:_.dialogs.wrongProportions.title,description:i.replace("{x}",this.validProportions[0].x).replace("{y}",this.validProportions[0].y).replace("{width}",this.minimumSize.width).replace("{height}",this.minimumSize.height).replace("{proportionsList}",t)}).show()},_setThumbnail:function(){var i={id:this.get("imageId"),provider:this.get("provider"),name:this.get("filename"),originalWidth:this.get("width"),originalHeight:this.get("height")};if(this.log("Setting editor thumbnail...",{image:i}),i.id&&i.provider){var e=this.validProportions&&this.validProportions[0]&&this.validProportions[0].x>0&&this.validProportions[0].y>0;if(!this.thumbnailImage)return void this.logWarn("No thumbnail node",this);let i=e?t.mixin(this,{constraints:{proportions:this.validProportions[0]}}):this;a(this.getThumbnailUrl(i),t.hitch(this,(function(i){if(!this.thumbnailImage||this.thumbnailImage.src&&this.thumbnailImage.src.endsWith(i)?this.log(`Thumbnail already set for '${this.name}', no need to refresh...`,this.thumbnailImage):(this.displayName?this.log(`Loading '${this.displayName}' thumbnail`,{url:i,formFactor:this.name}):this.log("Loading single image thumbnail",{url:i}),this.loader.show()),this.thumbnailImage){let t=new Image;t.addEventListener("load",function(){this.thumbnailImage&&this.thumbnailImage.setAttribute("src",i),this.dropzone&&h.add(this.dropzone,"adaptiveimages-details-editor__dropzone--hasThumbnail"),this.loader&&this.loader.hide(),this.thumbnailImage&&r.set(this.thumbnailImage,{display:"inherit"})}.bind(this)),t.addEventListener("error",function(){this.logError("Unable to load thumbnail",i),this.loader.hide(),this._dialogService.alertWithErrors({heading:_.dialogs.imageLoadError.title},[i])}.bind(this)),t.src=i}}))),h.remove(this.cropOption,"dijitReadOnly")}else r.set(this.thumbnailImage,{display:"none"}),h.remove(this.dropzone,"adaptiveimages-details-editor__dropzone--hasThumbnail"),h.add(this.cropOption,"dijitReadOnly"),this.loader.hide()},_setCropResetButtonVisibility:function(){this._hasCropSettings()?r.set(this.resetCropOption,"display","inherit"):r.set(this.resetCropOption,"display","none")},_hasCropSettings:function(){return this.get("right")>0||this.get("bottom")>0}})}));